import java.rmi.RemoteException;
import java.rmi.server.UnicastRemoteObject;


public class ServiceImpl extends UnicastRemoteObject implements Service{

	
	int val=1;
	public ServiceImpl() throws RemoteException {
		super();
	}
	
	@Override
	public int getVal() throws RemoteException {
		return val;
	}
	
	@Override
	public  synchronized int  setVal(int v, ItfClient cname) throws RemoteException {
		// la mthode est synchronized car il est interdit que plusieurs clients modifient val en meme temps
		val=val*v;
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {
			e.printStackTrace();
		}
		//System.out.println("Thread:"+Thread.currentThread().getName()+" val renvoyee :" + val + "au Client "+cname);
		Facture f=new Facture(v,cname.getName());// getName n'est plus invoque via le reseau, car cname correspond au smart proxy et rsultat de getName est dj l en local!
		cname.facturer(f); // le champ destinataire ne sera pas srialis car cname est le bon client: pas la peine de lui redire quel est son nom !
		// Il faut remarque que l'appel  facturer sur cname dclenche lui un vrai appel remote
		System.out.println("Nouvelle " + f);
		return val;
	}

}
