import java.io.Serializable;
import java.rmi.RemoteException;
public class SmartProxyClient implements ItfClient, Serializable {
	Facturation clientAFacturer = null;
	String clientName=null;
	public SmartProxyClient(Facturation c){
		clientAFacturer = c;
		try {
			clientName=clientAFacturer.getName(); // appel local ici
		} catch (RemoteException e) {
			clientName="anonyme";
			e.printStackTrace();
		}
	}
	@Override
	public void facturer(Facture f) throws RemoteException {
		clientAFacturer.facturer(f);
	}
	@Override
	public String getName() throws RemoteException{ // en soi, le throws est inutile... mais obligatoire dans l interface ItfClient
		System.out.println("Thread="+Thread.currentThread().getName()+" is calling getName()");
		return clientName;
	}
}
